C*********************************************************************
C
C     PROGRAM TQDVLOP
C
C     ʿʿѲ١ľʬۺץ(ȯŸ)
C
C     1998/09/22  
C     1998/10/02  
C     1999/01/17  
C     1999/06/15  
C
C*********************************************************************
      program tqdvlop
C---------------------------------------------------------------------  
      IMPLICIT REAL*8 ( A-H, O-Z )                                      
C---------------------------------------------------------------------  
#include "grid_size_M.f"
      parameter ( nzprof = 100 )                              
      parameter ( nzp = nz+1, ntp = 120 )
C---------------------------------------------------------------------  
C                                                                       
      character*5  nmrun
      character*4  from
      character*1  chara
      character*1  pz
      character*2  end
      character*2 day
      real*4 tend

      real*4  dtpad0,dqvad0
      real*4  zgrid(nzp)
      real*4  tptend(nzp),tpmean(nzp),dtpadv(nzp),
     &        dtpdif(nzp),dtpdnl(nzp),
     &        dtpdi0(nzp),dtprad(nzp),tperror(nzp),
     &        dtirad(nzp),dtsrad(nzp)

      real*8  qvtend(nzp),qvmean(nzp),dqvadv(nzp),
     &        dqvdif(nzp),dqvdnl(nzp),
     &        dqvdi0(nzp),dqvnfl(nzp),qverror(nzp)
      real*4  qvmean_4(nzp)

      real*4 tpmean0(nzp), tpmeanE(nzp), tpdiff

      integer fnum
      integer ibegin,iend,inter
      real*4 para1

      character*14 header
C
C=====================================================================  

      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu,times
      read (11,*) ylat, als
      close(11)

      write(day,'(I2.2)') irun-1

      write(6,*) 'data number = ', nloop1
      write(0,*) 'ibegin(1-', nloop1, 
     &           ') iend(1-', nloop1,  
     &           ') inter(1-', nloop1, ')'
      read (5,*) ibegin, iend, inter

      call sgpwsn
      read(*,*) iws

!      iws=2

      call gropn(iws)
      call sglset( 'LCORNER', .FALSE. )
C      call sldiv( 'Y', 2, 1 )

      call grfrm
      call grswnd( 180., 285., 0., 20. )
c      call grswnd( 230., 276., 0., 2. )
      call grsvpt( 0.2, 0.8, 0.2, 0.8 )
      call grstrn(1)
      call grstrf
      CALL ussttl( 'Temperature', '[K]', '', 'Z[km]' ) 
c      call ussttl ( 'THETA', '[K]', '', 'Z[km]' )
      call usdaxs

      para1 = 0.95

      type = 0.0

      do i = ibegin, iend+1, inter
c      do i = ibegin, iend, inter

         type = type + 0.1

C         fnum = 50 + i
         fnum = 49 + i
         open(fnum)

         read(fnum,'(a2,a15,g15.7,a6,g15.7,a4)') 
     &        chara, nmrun, t_begin, from, t_end,
     &        pz

         do iz = 1, nzp
            read(fnum,'(10g15.7)') zgrid(iz), 
     &           tperror(iz),
     &           tptend(iz),
     &           tpmean(iz),
     &           dtpadv(iz),
     &           dtpdif(iz),
     &           dtpdnl(iz),
     &           dtpad0,
     &           dtpdi0(iz),
     &           dtprad(iz),
     &           dtirad(iz),
     &           dtsrad(iz)
         end do

!===========================================================================
! check routine (2000/11/14)
         if ( fnum .eq. 50 ) then
            do iz = 1, NZP
               tpmean0(iz) = tpmean(iz) 
            end do
         end if

         if ( fnum .eq. 62 ) then
            do iz = 1, NZP
               tpmeanE(iz) = tpmean(iz) 
            end do
         end if
!===========================================================================


         close(fnum)

c         tend = t_end / 3600.
!********************************************************************
         tend   = (t_end -  ( irun - 1 )*86400.)/3600. + 6

         if ( INT(tend) .ge. 24 ) then
            tend = tend - 24
         end if

         write(end,500) INT(tend)
 500     format(I2.2)

         header = 'day' // day // ' LT=' // end // ':00'
!********************************************************************
         do iz = 1, nzp
            zgrid(iz) = zgrid(iz) / 1000.
         end do

         call sglset( 'LCHAR', .TRUE. )
         call sglset ( 'LROT', .TRUE. )
         call sgiset ( 'IROT', 90 )
         call sgrset ( 'FFCT', para1 )
         call uulinz(nzp, tpmean, zgrid, 1, 3)
         call sglset( 'LCHAR', .FALSE. )
         call sglset ( 'LROT', .FALSE. )
         para1 = para1 - 0.08
C         call uxsttl ( 'T', header, 1. )
      end do

      header='2D model'
      call uxsttl ( 'T', header, 1. )
*
*      
      tpdiff = 0.0
      do iz = 1, nzp
         tpdiff = MAX( tpdiff, ABS( tpmean0(iz) - tpmeanE(iz) ) )
      end do
      write(*,*) 'tpdiff=', tpdiff
      
      call grcls
      stop

!= vapor profile ========================================================

      call grfrm
      call grswnd( 0., 5.0e-5, 0., 20. )
      call grsvpt( 0.2, 0.8, 0.2, 0.8 )
      call grstrn(1)
      call grstrf
      call ussttl ( 'Q', '[kg/kg]', '', 'Z[km]' )
      call usdaxs

      do i = ibegin,iend,inter
         fnum = 50 + i
         open(fnum)

         open(fnum)

         read(fnum,'(a2,a15,g15.7,a8,g15.7,a4)') 
     &        chara, nmrun, t_begin, from, t_end,
     &        pz
       
         do iz = 1, nzp
            read(fnum,'(10g15.7)') zgrid(iz), 
     &           tperror(iz),
     &           tptend(iz),
     &           tpmean(iz),
     &           dtpadv(iz),
     &           dtpdif(iz),
     &           dtpdnl(iz),
     &           dtpad0,
     &           dtpdi0(iz),
     &           dtprad(iz),
     &           dtirad(iz),
     &           dtsrad(iz)
         end do
      
         read(fnum,'(a2,a15,g15.7,a6,g15.7,a4)') 
     &        chara, nmrun, t_begin, from, t_end,
     &        pz

         do iz = 1, nzp
            read(fnum,'(10g15.7)') zgrid(iz),
     &           qvtend(iz),
     &           qvmean(iz),
     &           dqvadv(iz),
     &           dqvdif(iz),
     &           dqvdnl(iz),
     &           dqvad0,
     &           dqvdi0(iz),
     &           dqvnfl(iz),
     &           qverror(iz)
         end do

         close(fnum)

         tend = t_end / 3600.
         write(end,500) INT(tend)

         do iz = 1, nzp
            zgrid(iz) = zgrid(iz) / 1000.
         end do

C         call sglset( 'LCHAR', .TRUE. )
C         call sgsplc( end ) 
C         call sglset ( 'LROT', .TRUE. )
C         call sgiset ( 'IROT', 90 )
C         call sgrset ( 'FFCT', 0.5 )

         do iz = 1,nzp
            qvmean_4(iz) = REAL(qvmean(iz))
         end do

         call uulin(nzp, qvmean_4, zgrid)
C         call sglset( 'LCHAR', .FALSE. )
C         call sglset ( 'LROT', .FALSE. )

      end do

      header='2D model'
      call uxsttl ( 'T', header, 1. )
      call grcls


      end
